//--------------------------------------------------------------------- 
#include "cccheck.h"
//--------------------------------------------------------------------- 
long CheckCode(const unsigned char *sce,const long i,
               enum CCODETYPE &code,enum CRETURNCODE &ret)
{
    long newposition;

    if(sce[i]<=6 || sce[i]==0xff)
    {
        code=ccBINARY;
        return i+1;
    }

    if(sce[i]==0x0d && sce[i+1]==0x0a)
        ret=rcCRLF;
    else
    if(sce[i]==0x0a && i>0)
        if(sce[i-1]==0x0d)
            ret=rcCRLF;

    newposition=i;

    switch(code)
    {
        case ccJIS:
            if((sce[i]==0x1b && sce[i+1]==0x28 && sce[i+2]=='J') ||
               ((sce[i]==0x1b && sce[i+1]==0x24 && 
                (sce[i+2]=='B' || sce[i+2]=='@')) &&
                ((sce[i+3]>=0x10 && sce[i+3]<=0x1f) || 
                 (sce[i+3]>=0x21 && sce[i+3]<=0x7f))))
                    newposition=i+3;
            else
            if(((sce[i]>=0x10 && sce[i]<=0x1f) || 
                (sce[i]>=0x21 && sce[i]<=0x7f)) &&
               (sce[i+1]>=0xa0 && sce[i+1]<=0xfe))
                newposition=i+2;
            else
            if(sce[i]<0x80 || (sce[i]>=0xa1 && sce[i]<=0xdf))
                newposition=i+1;
            else
                code=ccBINARY;
            break;
        case ccSJIS:
            if(((sce[i]>=0x81 && sce[i]<=0x9f) || 
                (sce[i]>=0xe0 && sce[i]<=0xfc)) &&
               ((sce[i+1]>=0x40 && sce[i+1]<=0x7e) || 
                (sce[i+1]>=0x80 && sce[i+1]<=0xfc)))
                newposition=i+2;
            else
            if(sce[i]<0x80 || (sce[i]>=0xa1 && sce[i]<=0xdf))
                newposition=i+1;
            else
                code=ccBINARY;
            break;
        case ccEUC:
            if((sce[i]==0x8e || (sce[i]>=0x90 && sce[i]<=0x9f) || 
               (sce[i]>=0xa1 && sce[i]<=0xfe)) &&
               (sce[i+1]>=0xa0 && sce[i+1]<=0xfe))
                newposition=i+2;
            else
            if(sce[i]<0x80)
                newposition=i+1;
            else
                code=ccBINARY;
            break;
        case ccSJISorEUC:
            if((((sce[i]>=0x81 && sce[i]<=0x8d) || sce[i]==0x8f) &&
                ((sce[i+1]>=0x40 && sce[i+1]<=0x7e) || 
                 (sce[i+1]>=0x80 && sce[i+1]<=0xfc))) ||
               (((sce[i]>=0x81 && sce[i]<=0x9f) || 
                 (sce[i]>=0xe0 && sce[i]<=0xfc)) &&
                ((sce[i+1]>=0x40 && sce[i+1]<=0x7e) || 
                 (sce[i+1]>=0x80 && sce[i+1]<=0x9f))))
            {
                code=ccSJIS;
                newposition=i+2;
            }
            else
            if((((sce[i]>=0xa1 && sce[i]<=0xdf) || sce[i]==0xfd || 
                  sce[i]==0xfe) &&
                (sce[i+1]>=0xa0 && sce[i+1]<=0xfe)) ||
               ((sce[i]==0x8e || (sce[i]>=0x90 && sce[i]<=0x9f) || 
                (sce[i]>=0xa1 && sce[i]<=0xfe)) &&
                (sce[i+1]==0xfd || sce[i+1]==0xfe)))
            {
                code=ccEUC;
                newposition=i+2;
            }
            else
            if((sce[i]==0x8e || (sce[i]>=0x90 && sce[i]<=0x9f) || 
               (sce[i]>=0xe0 && sce[i]<=0xfc)) &&
               (sce[i+1]>=0xa0 && sce[i+1]<=0xfc))
            {
                code=ccSJISorEUC;
                newposition=i+2;
            }
            else
            if(sce[i]>=0xa1 && sce[i]<=0xdf)
            {
                code=ccSJIS;
                newposition=i+1;
            }
            else
            if(sce[i]<0x80)
                newposition=i+1;
            else            
                code=ccBINARY;
            break;
        case ccOther:
            if((sce[i]==0x1b && sce[i+1]==0x24 && 
               (sce[i+2]=='B' || sce[i+2]=='@')) &&
               ((sce[i+3]>=0x10 && sce[i+3]<=0x1f) || 
                (sce[i+3]>=0x21 && sce[i+3]<=0x7e)))
            {
                code=ccJIS;
                newposition=i+3;
            }
            else
            if((((sce[i]>=0x81 && sce[i]<=0x8d) || sce[i]==0x8f) &&
                ((sce[i+1]>=0x40 && sce[i+1]<=0x7e) || 
                 (sce[i+1]>=0x80 && sce[i+1]<=0xfc))) ||
               (((sce[i]>=0x81 && sce[i]<=0x9f) || 
                 (sce[i]>=0xe0 && sce[i]<=0xfc)) &&
                ((sce[i+1]>=0x40 && sce[i+1]<=0x7e) || 
                 (sce[i+1]>=0x80 && sce[i+1]<=0x9f))))
            {
                code=ccSJIS;
                newposition=i+2;
            }
            else
            if((((sce[i]>=0xa1 && sce[i]<=0xdf) || sce[i]==0xfd || 
                  sce[i]==0xfe) &&
                (sce[i+1]>=0xa0 && sce[i+1]<=0xfe)) ||
               ((sce[i]==0x8e || (sce[i]>=0x90 && sce[i]<=0x9f) || 
                (sce[i]>=0xa1 && sce[i]<=0xfe)) &&
                (sce[i+1]==0xfd || sce[i+1]==0xfe)))
            {
                code=ccEUC;
                newposition=i+2;
            }
            else
            if((sce[i]==0x8e || (sce[i]>=0x90 && sce[i]<=0x9f) || 
               (sce[i]>=0xe0 && sce[i]<=0xfc)) &&
               (sce[i+1]>=0xa0 && sce[i+1]<=0xfc))
            {
                code=ccSJISorEUC;
                newposition=i+2;
            }
            else
            if(sce[i]<0x80 || (sce[i]>=0xa1 && sce[i]<=0xdf))
                newposition=i+1;
            else
                code=ccBINARY;
            break;
        default:
            code=ccBINARY;
    }

    return newposition;
}
//--------------------------------------------------------------------- 
void CheckCharCodeType(const unsigned char *sce,enum CCODETYPE &code,
                       enum CRETURNCODE &ret,const long checklen)
{
    ret=rcLF;
    code=ccOther;

    long i=0;
    long len;

    len=strlen((char *)sce);

    while(code!=ccBINARY && i<len-4 && i<checklen)
        i=CheckCode(sce,i,code,ret);

    if(code==ccOther)
        code=ccASCII;
}
//--------------------------------------------------------------------- 
